/*! *****************************************************************************
Copyright (c) Microsoft Corporation. All rights reserved.
Licensed under the Apache License, Version 2.0 (the "License"); you may not use
this file except in compliance with the License. You may obtain a copy of the
License at http://www.apache.org/licenses/LICENSE-2.0

THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
MERCHANTABLITY OR NON-INFRINGEMENT.

See the Apache Version 2.0 License for specific language governing permissions
and limitations under the License.
***************************************************************************** */
/* global Reflect, Promise */

var extendStatics = function(d, b) {
    extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return extendStatics(d, b);
};

function __extends(d, b) {
    extendStatics(d, b);
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
}

var __assign = function() {
    __assign = Object.assign || function __assign(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};

function __awaiter(thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
}

function __generator(thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
}

function __spreadArrays() {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
}

var EMPTY = {};
function generateMessageId() {
    return Math.random()
        .toString(36)
        .slice(2);
}
function addMissingState(graphData) {
    var updatedGraphData = __assign({}, graphData);
    var now = new Date().getTime();
    for (var soul in graphData) {
        var node = graphData[soul];
        if (!node)
            continue;
        var meta = (node._ = node._ || {});
        meta['#'] = soul;
        var state = (meta['>'] = meta['>'] || {});
        for (var key in node) {
            if (key === '_')
                continue;
            state[key] = state[key] || now;
        }
        updatedGraphData[soul] = node;
    }
    return updatedGraphData;
}
var DEFAULT_OPTS = {
    futureGrace: 10 * 60 * 1000,
    Lexical: JSON.stringify // what gun.js uses
};
function diffGunCRDT(updatedGraph, existingGraph, opts) {
    if (opts === void 0) { opts = DEFAULT_OPTS; }
    var _a = opts || EMPTY, _b = _a.machineState, machineState = _b === void 0 ? new Date().getTime() : _b, _c = _a.futureGrace, futureGrace = _c === void 0 ? DEFAULT_OPTS.futureGrace : _c, _d = _a.Lexical, Lexical = _d === void 0 ? DEFAULT_OPTS.Lexical : _d;
    var maxState = machineState + futureGrace; // eslint-disable-line
    var allUpdates = {};
    for (var soul in updatedGraph) {
        var existing = existingGraph[soul];
        var updated = updatedGraph[soul];
        var existingState = (existing && existing._ && existing._['>']) || EMPTY;
        var updatedState = (updated && updated._ && updated._['>']) || EMPTY;
        if (!updated) {
            if (!(soul in existingGraph))
                allUpdates[soul] = updated;
            continue;
        }
        var hasUpdates = false;
        var updates = {
            _: {
                '#': soul,
                '>': {}
            }
        };
        for (var key in updatedState) {
            var existingKeyState = existingState[key];
            var updatedKeyState = updatedState[key];
            if (updatedKeyState > maxState || !updatedKeyState)
                continue;
            if (existingKeyState && existingKeyState >= updatedKeyState)
                continue;
            if (existingKeyState === updatedKeyState) {
                var existingVal = (existing && existing[key]) || undefined;
                var updatedVal = updated[key];
                // This is based on Gun's logic
                if (Lexical(updatedVal) <= Lexical(existingVal))
                    continue;
            }
            updates[key] = updated[key];
            updates._['>'][key] = updatedKeyState;
            hasUpdates = true;
        }
        if (hasUpdates) {
            allUpdates[soul] = updates;
        }
    }
    return Object.keys(allUpdates) ? allUpdates : undefined;
}
function diffSets(initial, updated) {
    return [
        updated.filter(function (key) { return initial.indexOf(key) === -1; }),
        initial.filter(function (key) { return updated.indexOf(key) === -1; })
    ];
}
function mergeGunNodes(existing, updates) {
    if (!existing)
        return updates;
    if (!updates)
        return existing;
    var existingMeta = existing._;
    return __assign(__assign(__assign({}, existing), updates), { _: {
            '#': existingMeta['#'],
            '>': __assign(__assign({}, existingMeta['>']), updates._['>'])
        } });
}
function mergeGraph(existing, diff) {
    var result = __assign({}, existing);
    for (var soul in diff) {
        result[soul] = mergeGunNodes(existing[soul], diff[soul]);
    }
    return result;
}
function nodeToGraph(node) {
    var _a;
    var modified = __assign({}, node);
    var nodes = {};
    var nodeSoul = node && node._ && node._['#'];
    for (var key in node) {
        if (key === '_')
            continue;
        var val = node[key];
        if (typeof val !== 'object')
            continue;
        var soul = val && val._ && val._['#'];
        if (soul) {
            var edge = { '#': soul };
            modified[key] = edge;
            var graph = addMissingState(nodeToGraph(val));
            var diff_1 = diffGunCRDT(graph, nodes);
            nodes = diff_1 ? mergeGraph(nodes, diff_1) : nodes;
        }
    }
    var raw = (_a = {}, _a[nodeSoul] = modified, _a);
    var withMissingState = addMissingState(raw);
    var diff = diffGunCRDT(withMissingState, nodes);
    nodes = diff ? mergeGraph(nodes, diff) : nodes;
    return nodes;
}
function flattenGraphData(data) {
    var graphs = [];
    var flatGraph = {};
    for (var soul in data) {
        var node = data[soul];
        if (node)
            graphs.push(nodeToGraph(node));
    }
    for (var i = 0; i < graphs.length; i++) {
        var diff = diffGunCRDT(graphs[i], flatGraph);
        flatGraph = diff ? mergeGraph(flatGraph, diff) : flatGraph;
    }
    return flatGraph;
}
function getPathData(keys, graph) {
    var lastKey = keys[keys.length - 1];
    if (keys.length === 1) {
        return {
            souls: keys,
            value: graph[lastKey],
            complete: lastKey in graph
        };
    }
    var _a = getPathData(keys.slice(0, keys.length - 1), graph), parentValue = _a.value, souls = _a.souls;
    if (typeof parentValue !== 'object') {
        return {
            souls: souls,
            value: undefined,
            complete: typeof parentValue !== 'undefined'
        };
    }
    var value = parentValue[lastKey];
    if (!value) {
        return {
            souls: souls,
            value: value,
            complete: true
        };
    }
    var edgeSoul = value['#'];
    if (edgeSoul) {
        return {
            souls: __spreadArrays(souls, [edgeSoul]),
            value: graph[edgeSoul],
            complete: edgeSoul in graph
        };
    }
    return {
        souls: souls,
        value: value,
        complete: true
    };
}

/**
 * Generic event/listener system
 */
var GunEvent = /** @class */ (function () {
    function GunEvent(name) {
        if (name === void 0) { name = 'GunEvent'; }
        this.name = name;
        this._listeners = [];
        this.listenerCount = this.listenerCount.bind(this);
        this.on = this.on.bind(this);
        this.off = this.off.bind(this);
        this.trigger = this.trigger.bind(this);
    }
    /**
     * @returns number of currently subscribed listeners
     */
    GunEvent.prototype.listenerCount = function () {
        return this._listeners.length;
    };
    /**
     * Register a listener on this event
     *
     * @param cb the callback to subscribe
     */
    GunEvent.prototype.on = function (cb) {
        if (this._listeners.indexOf(cb) !== -1)
            return;
        this._listeners.push(cb);
        return this;
    };
    /**
     * Unregister a listener on this event
     * @param cb the callback to unsubscribe
     */
    GunEvent.prototype.off = function (cb) {
        var idx = this._listeners.indexOf(cb);
        if (idx !== -1)
            this._listeners.splice(idx, 1);
        return this;
    };
    /**
     * Unregister all listeners on this event
     */
    GunEvent.prototype.reset = function () {
        this._listeners = [];
        return this;
    };
    /**
     * Trigger this event
     */
    GunEvent.prototype.trigger = function (a, b, c) {
        this._listeners.forEach(function (cb) { return cb(a, b, c); });
        return this;
    };
    return GunEvent;
}());

var ChainGunLink = /** @class */ (function () {
    function ChainGunLink(chain, key, parent) {
        this.key = key;
        if (!parent)
            this.soul = key;
        this._chain = chain;
        this._parent = parent;
        this._hasReceived = false;
        this._updateEvent = new GunEvent(this.getPath().join('|'));
    }
    ChainGunLink.prototype.getPath = function () {
        if (this._parent)
            return __spreadArrays(this._parent.getPath(), [this.key]);
        return [this.key];
    };
    /**
     * Traverse a location in the graph
     *
     * @param key Key to read data from
     * @param cb
     * @returns New chain context corresponding to given key
     */
    ChainGunLink.prototype.get = function (key, cb) {
        return new this.constructor(this._chain, key, this);
    };
    /**
     * Move up to the parent context on the chain.
     *
     * Every time a new chain is created, a reference to the old context is kept to go back to.
     *
     * @param amount The number of times you want to go back up the chain. {-1} or {Infinity} will take you to the root.
     * @returns a parent chain context
     */
    ChainGunLink.prototype.back = function (amount) {
        if (amount === void 0) { amount = 1; }
        if (amount < 0 || amount === Infinity)
            return this._chain;
        if (amount === 1)
            return this._parent || this._chain;
        return this.back(amount - 1);
    };
    /**
     * Save data into gun, syncing it with your connected peers.
     *
     * You do not need to re-save the entire object every time, gun will automatically
     * merge your data into what already exists as a "partial" update.
     *
     * @param value the data to save
     * @param cb an optional callback, invoked on each acknowledgment
     * @returns same chain context
     */
    ChainGunLink.prototype.put = function (value, cb) {
        this._chain.graph.putPath(this.getPath(), value, cb);
        return this;
    };
    /**
     * Add a unique item to an unordered list.
     *
     * Works like a mathematical set, where each item in the list is unique.
     * If the item is added twice, it will be merged.
     * This means only objects, for now, are supported.
     *
     * @param data should be a gun reference or an object
     * @param cb The callback is invoked exactly the same as .put
     * @returns chain context for added object
     */
    ChainGunLink.prototype.set = function (data, cb) {
        var _a, _b;
        if (data instanceof ChainGunLink && data.soul) {
            this.put((_a = {},
                _a[data.soul] = {
                    '#': data.soul
                },
                _a), cb);
        }
        else if (data && data._ && data._['#']) {
            this.put((_b = {},
                _b[data && data._ && data._['#']] = data,
                _b), cb);
        }
        else {
            throw new Error('set() is only partially supported');
        }
    };
    /**
     * Register a callback for when it appears a record does not exist
     *
     * If you need to know whether a property or key exists, you can check with .not.
     * It will consult the connected peers and invoke the callback if there's reasonable certainty that none of them have the data available.
     *
     * @param cb If there's reason to believe the data doesn't exist, the callback will be invoked. This can be used as a check to prevent implicitly writing data
     * @returns same chain context
     */
    ChainGunLink.prototype.not = function (cb) {
        var _this = this;
        this.promise().then(function (val) { return typeof val === 'undefined' && cb(_this.key); });
        return this;
    };
    /**
     * Change the configuration of this chain link
     *
     * @param options
     * @returns same chain context
     */
    ChainGunLink.prototype.opt = function (options) {
        return this;
    };
    /**
     * Get the current data without subscribing to updates. Or undefined if it cannot be found.
     *
     * @param cb The data is the value for that chain at that given point in time. And the key is the last property name or ID of the node.
     * @returns same chain context
     */
    ChainGunLink.prototype.once = function (cb) {
        var _this = this;
        this.promise().then(function (val) { return cb(val, _this.key); });
        return this;
    };
    /**
     * Subscribe to updates and changes on a node or property in realtime.
     *
     * Triggered once initially and whenever the property or node you're focused on changes,
     * Since gun streams data, the callback will probably be called multiple times as new chunk comes in.
     *
     * To remove a listener call .off() on the same property or node.
     *
     * @param cb The callback is immediately fired with the data as it is at that point in time.
     * @returns same chain context
     */
    ChainGunLink.prototype.on = function (cb) {
        this._updateEvent.on(cb);
        if (!this._endQuery) {
            this._endQuery = this._chain.graph.query(this.getPath(), this._onQueryResponse.bind(this));
        }
        if (this._hasReceived)
            cb(this._lastValue, this.key);
        return this;
    };
    /**
     * Unsubscribe one or all listeners subscribed with on
     *
     * @returns same chain context
     */
    ChainGunLink.prototype.off = function (cb) {
        if (cb) {
            this._updateEvent.off(cb);
            if (this._endQuery && !this._updateEvent.listenerCount()) {
                this._endQuery();
            }
        }
        else {
            if (this._endQuery) {
                this._endQuery();
            }
            this._updateEvent.reset();
        }
        return this;
    };
    ChainGunLink.prototype.promise = function (opts) {
        var _this = this;
        if (opts === void 0) { opts = { timeout: 0 }; }
        return new Promise(function (ok) {
            var cb = function (val) {
                ok(val);
                _this.off(cb);
            };
            _this.on(cb);
            if (opts.timeout)
                setTimeout(function () { return ok(); }, opts.timeout);
        });
    };
    ChainGunLink.prototype.then = function (fn) {
        return this.promise().then(fn);
    };
    /**
     * Iterates over each property and item on a node, passing it down the chain
     *
     * Not yet supported
     *
     * Behaves like a forEach on your data.
     * It also subscribes to every item as well and listens for newly inserted items.
     *
     * @returns a new chain context holding many chains simultaneously.
     */
    ChainGunLink.prototype.map = function () {
        throw new Error("map() isn't supported yet");
        return this.get(''); // Special case key
    };
    /**
     * No plans to support this
     */
    ChainGunLink.prototype.path = function (path) {
        throw new Error('No plans to support this');
    };
    /**
     * No plans to support this
     */
    ChainGunLink.prototype.open = function (cb) {
        throw new Error('No plans to support this');
    };
    /**
     * No plans to support this
     */
    ChainGunLink.prototype.load = function (cb) {
        throw new Error('No plans to support this');
    };
    /**
     * No plans to support this
     */
    ChainGunLink.prototype.bye = function () {
        throw new Error('No plans to support this');
    };
    /**
     * No plans to support this
     */
    ChainGunLink.prototype.later = function () {
        throw new Error('No plans to support this');
    };
    /**
     * No plans to support this
     */
    ChainGunLink.prototype.unset = function (node) {
        throw new Error('No plans to support this');
    };
    ChainGunLink.prototype._onQueryResponse = function (value) {
        this._updateEvent.trigger(value, this.key);
        this._lastValue = value;
        this._hasReceived = true;
    };
    return ChainGunLink;
}());

/**
 * Query state around a single node in the graph
 */
var GunGraphNode = /** @class */ (function () {
    function GunGraphNode(graph, soul, updateGraph) {
        this._data = new GunEvent("<GunGraphNode " + soul + ">");
        this._graph = graph;
        this._updateGraph = updateGraph;
        this.soul = soul;
    }
    GunGraphNode.prototype.listenerCount = function () {
        return this._data.listenerCount();
    };
    GunGraphNode.prototype.get = function (cb) {
        if (cb)
            this.on(cb);
        this._ask();
        return this;
    };
    GunGraphNode.prototype.receive = function (data) {
        this._data.trigger(data, this.soul);
        return this;
    };
    GunGraphNode.prototype.on = function (cb) {
        this._data.on(cb);
        return this;
    };
    GunGraphNode.prototype.off = function (cb) {
        if (cb) {
            this._data.off(cb);
        }
        else {
            this._data.reset();
        }
        if (this._endCurQuery && !this._data.listenerCount()) {
            this._endCurQuery();
            this._endCurQuery = undefined;
        }
        return this;
    };
    GunGraphNode.prototype._ask = function () {
        var _this = this;
        if (this._endCurQuery)
            return;
        var endFns = [];
        var msgId = generateMessageId();
        this._graph.eachConnector(function (connector) {
            endFns.push(connector.get({
                msgId: msgId,
                soul: _this.soul,
                cb: _this._onDirectQueryReply.bind(_this)
            }));
        });
        this._endCurQuery = function () { return endFns.map(function (fn) { return fn(); }); };
        return this;
    };
    GunGraphNode.prototype._onDirectQueryReply = function (msg) {
        var _a;
        if ('put' in msg && !msg.put) {
            this._updateGraph((_a = {},
                _a[this.soul] = undefined,
                _a), msg['@']);
        }
    };
    return GunGraphNode;
}());

/**
 * High level management of a subset of the gun graph
 *
 * Provides facilities for querying and writing to graph data from one or more sources
 */
var GunGraph = /** @class */ (function () {
    function GunGraph() {
        this.id = generateMessageId();
        this._receiveGraphData = this._receiveGraphData.bind(this);
        this.__onConnectorStatus = this.__onConnectorStatus.bind(this);
        this.activeConnectors = 0;
        this.graphData = new GunEvent('graph data');
        this._opt = {};
        this._graph = {};
        this._nodes = {};
        this._connectors = [];
        this._readMiddleware = [];
        this._writeMiddleware = [];
    }
    /**
     * Configure graph options
     *
     * Currently unused
     *
     * @param options
     */
    GunGraph.prototype.opt = function (options) {
        this._opt = __assign(__assign({}, this._opt), options);
        return this;
    };
    /**
     * Connect to a source/destination for graph data
     *
     * @param connector the source or destination for graph data
     */
    GunGraph.prototype.connect = function (connector) {
        if (this._connectors.indexOf(connector) !== -1)
            return this;
        if (connector.isConnected)
            this.activeConnectors++;
        connector.events.connection.on(this.__onConnectorStatus);
        connector.events.graphData.on(this._receiveGraphData);
        this._connectors.push(connector);
        return this;
    };
    /**
     * Disconnect from a source/destination for graph data
     *
     * @param connector the source or destination for graph data
     */
    GunGraph.prototype.disconnect = function (connector) {
        var idx = this._connectors.indexOf(connector);
        connector.events.graphData.off(this._receiveGraphData);
        connector.events.connection.off(this.__onConnectorStatus);
        if (idx !== -1)
            this._connectors.splice(idx, 1);
        if (connector.isConnected)
            this.activeConnectors--;
        return this;
    };
    /**
     * Register graph middleware
     *
     * @param middleware The middleware function to add
     * @param kind Optionaly register write middleware instead of read by passing "write"
     */
    GunGraph.prototype.use = function (middleware, kind) {
        if (kind === void 0) { kind = 'read'; }
        if (kind === 'read') {
            this._readMiddleware.push(middleware);
        }
        else if (kind === 'write') {
            this._writeMiddleware.push(middleware);
        }
        return this;
    };
    /**
     * Unregister graph middleware
     *
     * @param middleware The middleware function to remove
     * @param kind Optionaly unregister write middleware instead of read by passing "write"
     */
    GunGraph.prototype.unuse = function (middleware, kind) {
        if (kind === void 0) { kind = 'read'; }
        if (kind === 'read') {
            var idx = this._readMiddleware.indexOf(middleware);
            if (idx !== -1)
                this._readMiddleware.splice(idx, 1);
        }
        else if (kind === 'write') {
            var idx = this._writeMiddleware.indexOf(middleware);
            if (idx !== -1)
                this._writeMiddleware.splice(idx, 1);
        }
        return this;
    };
    /**
     * Read a potentially multi-level deep path from the graph
     *
     * @param path The path to read
     * @param cb The callback to invoke with results
     * @returns a cleanup function to after done with query
     */
    GunGraph.prototype.query = function (path, cb) {
        var _this = this;
        var lastSouls = [];
        var currentValue;
        var updateQuery = function () {
            var _a = getPathData(path, _this._graph), souls = _a.souls, value = _a.value, complete = _a.complete;
            var _b = diffSets(lastSouls, souls), added = _b[0], removed = _b[1];
            if ((complete && typeof currentValue === 'undefined') ||
                (typeof value !== 'undefined' && value !== currentValue)) {
                currentValue = value;
                cb(value, path[path.length - 1]);
            }
            for (var i = 0; i < added.length; i++) {
                _this._requestSoul(added[i], updateQuery);
            }
            for (var i = 0; i < removed.length; i++) {
                _this._unlistenSoul(removed[i], updateQuery);
            }
            lastSouls = souls;
        };
        updateQuery();
        return function () {
            for (var i = 0; i < lastSouls.length; i++) {
                _this._unlistenSoul(lastSouls[i], updateQuery);
            }
        };
    };
    /**
     * Write graph data to a potentially multi-level deep path in the graph
     *
     * @param path The path to read
     * @param data The value to write
     * @param cb Callback function to be invoked for write acks
     * @returns a cleanup function to after done with query
     */
    GunGraph.prototype.putPath = function (path, data, cb) {
        var _a;
        var _this = this;
        if (path.length === 1) {
            if (data && typeof data === 'object') {
                this.put((_a = {},
                    _a[path[0]] = data,
                    _a), cb);
            }
            return;
        }
        var lastKey = path[path.length - 1];
        var parentPath = path.slice(0, path.length - 1);
        var lastSouls = [];
        var end = function () {
            for (var i = 0; i < lastSouls.length; i++) {
                _this._unlistenSoul(lastSouls[i], updateQuery);
            }
            lastSouls = [];
        };
        var updateQuery = function () {
            var _a;
            var _b = getPathData(path, _this._graph), souls = _b.souls, complete = _b.complete;
            var _c = diffSets(lastSouls, souls), added = _c[0], removed = _c[1];
            if (complete) {
                if (souls.length === parentPath.length) {
                    var lastSoul = souls[souls.length - 1];
                    _this.putPath([lastSoul], (_a = {}, _a[lastKey] = data, _a), cb);
                }
                else {
                    throw new Error('Deep puts only partially supported');
                }
                end();
            }
            else {
                for (var i = 0; i < added.length; i++) {
                    _this._requestSoul(added[i], updateQuery);
                }
                for (var i = 0; i < removed.length; i++) {
                    _this._unlistenSoul(removed[i], updateQuery);
                }
            }
            lastSouls = souls;
        };
        updateQuery();
        return end;
    };
    /**
     * Write node data
     *
     * @param data one or more gun nodes keyed by soul
     */
    GunGraph.prototype.put = function (data, cb) {
        return __awaiter(this, void 0, void 0, function () {
            var diff, i, msgId, i, souls, i;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        diff = flattenGraphData(addMissingState(data));
                        i = 0;
                        _a.label = 1;
                    case 1:
                        if (!(i < this._writeMiddleware.length)) return [3 /*break*/, 4];
                        if (!diff)
                            return [2 /*return*/];
                        return [4 /*yield*/, this._writeMiddleware[i](diff, this._graph)];
                    case 2:
                        diff = _a.sent();
                        _a.label = 3;
                    case 3:
                        i++;
                        return [3 /*break*/, 1];
                    case 4:
                        if (!diff)
                            return [2 /*return*/];
                        msgId = generateMessageId();
                        for (i = 0; i < this._connectors.length; i++) {
                            this._connectors[i].put({
                                msgId: msgId,
                                graph: diff,
                                cb: cb
                            });
                        }
                        souls = Object.keys(diff);
                        for (i = 0; i < souls.length; i++) {
                            this._node(souls[i]);
                        }
                        this._receiveGraphData(diff);
                        return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Synchronously invoke callback function for each connector to this graph
     *
     * @param cb The callback to invoke
     */
    GunGraph.prototype.eachConnector = function (cb) {
        for (var i = 0; i < this._connectors.length; i++) {
            cb(this._connectors[i]);
        }
        return this;
    };
    /**
     * Update graph data in this chain from some local or external source
     *
     * @param data node data to include
     */
    GunGraph.prototype._receiveGraphData = function (data, id, replyToId) {
        return __awaiter(this, void 0, void 0, function () {
            var diff, i, souls, i, soul, node, nodeData;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        diff = data;
                        i = 0;
                        _a.label = 1;
                    case 1:
                        if (!(i < this._readMiddleware.length)) return [3 /*break*/, 4];
                        if (!diff)
                            return [2 /*return*/];
                        return [4 /*yield*/, this._readMiddleware[i](diff, this._graph)];
                    case 2:
                        diff = _a.sent();
                        _a.label = 3;
                    case 3:
                        i++;
                        return [3 /*break*/, 1];
                    case 4:
                        if (!diff)
                            return [2 /*return*/];
                        souls = Object.keys(diff);
                        for (i = 0; i < souls.length; i++) {
                            soul = souls[i];
                            node = this._nodes[soul];
                            if (!node) {
                                this._forgetSoul(soul);
                                continue;
                            }
                            nodeData = (this._graph[soul] = mergeGunNodes(this._graph[soul], diff[soul]));
                            if (node)
                                node.receive(nodeData);
                        }
                        this.graphData.trigger(diff, id, replyToId);
                        return [2 /*return*/];
                }
            });
        });
    };
    GunGraph.prototype._node = function (soul) {
        return (this._nodes[soul] =
            this._nodes[soul] || new GunGraphNode(this, soul, this._receiveGraphData));
    };
    GunGraph.prototype._requestSoul = function (soul, cb) {
        this._node(soul).get(cb);
        return this;
    };
    GunGraph.prototype._unlistenSoul = function (soul, cb) {
        var node = this._nodes[soul];
        if (!node)
            return this;
        node.off(cb);
        if (node.listenerCount() <= 0) {
            node.off();
            this._forgetSoul(soul);
        }
        return this;
    };
    GunGraph.prototype._forgetSoul = function (soul) {
        var node = this._nodes[soul];
        if (node) {
            node.off();
            delete this._nodes[soul];
        }
        delete this._graph[soul];
        return this;
    };
    GunGraph.prototype.__onConnectorStatus = function (connected) {
        if (connected) {
            this.activeConnectors++;
        }
        else {
            this.activeConnectors--;
        }
    };
    return GunGraph;
}());

var GunQueue = /** @class */ (function () {
    function GunQueue(name) {
        if (name === void 0) { name = "GunQueue"; }
        this.name = name;
        this._queue = [];
    }
    GunQueue.prototype.count = function () {
        return this._queue.length;
    };
    GunQueue.prototype.enqueue = function (item) {
        if (this._queue.indexOf(item) !== -1)
            return this;
        this._queue.splice(0, 0, item);
        return this;
    };
    GunQueue.prototype.dequeue = function () {
        return this._queue.pop();
    };
    GunQueue.prototype.enqueueMany = function (items) {
        var _a;
        (_a = this._queue).splice.apply(_a, __spreadArrays([0, 0], items.slice().reverse()));
        return this;
    };
    return GunQueue;
}());

var MiddlewareSystem = /** @class */ (function () {
    function MiddlewareSystem(name) {
        if (name === void 0) { name = 'MiddlewareSystem'; }
        this.name = name;
        this._middlewareFunctions = [];
    }
    /**
     * Register middleware function
     *
     * @param middleware The middleware function to add
     */
    MiddlewareSystem.prototype.use = function (middleware) {
        if (this._middlewareFunctions.indexOf(middleware) !== -1)
            return;
        this._middlewareFunctions.push(middleware);
        return this;
    };
    /**
     * Unregister middleware function
     *
     * @param middleware The middleware function to remove
     */
    MiddlewareSystem.prototype.unuse = function (middleware) {
        var idx = this._middlewareFunctions.indexOf(middleware);
        if (idx !== -1)
            this._middlewareFunctions.splice(idx, 1);
        return this;
    };
    /**
     * Process values through this middleware
     * @param a Required, this is the value modified/passed through each middleware fn
     * @param b Optional extra argument passed to each middleware function
     * @param c Optional extra argument passed to each middleware function
     */
    MiddlewareSystem.prototype.process = function (a, b, c) {
        return __awaiter(this, void 0, void 0, function () {
            var val, i;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        val = a;
                        i = 0;
                        _a.label = 1;
                    case 1:
                        if (!(i < this._middlewareFunctions.length)) return [3 /*break*/, 4];
                        if (!val)
                            return [2 /*return*/];
                        return [4 /*yield*/, this._middlewareFunctions[i](val, b, c)];
                    case 2:
                        val = _a.sent();
                        _a.label = 3;
                    case 3:
                        i++;
                        return [3 /*break*/, 1];
                    case 4: return [2 /*return*/, val];
                }
            });
        });
    };
    return MiddlewareSystem;
}());

var GunProcessQueue = /** @class */ (function (_super) {
    __extends(GunProcessQueue, _super);
    function GunProcessQueue(name) {
        if (name === void 0) { name = "GunProcessQueue"; }
        var _this = _super.call(this, name) || this;
        _this.isProcessing = false;
        _this.completed = new GunEvent(name + "._processed");
        _this.middleware = new MiddlewareSystem(name + ".middleware");
        return _this;
    }
    GunProcessQueue.prototype.processNext = function (b, c) {
        return __awaiter(this, void 0, void 0, function () {
            var item;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        item = this.dequeue();
                        if (!item)
                            return [2 /*return*/, item];
                        return [4 /*yield*/, this.middleware.process(item, b, c)];
                    case 1:
                        item = _a.sent();
                        if (item)
                            this.completed.trigger(item);
                        return [2 /*return*/];
                }
            });
        });
    };
    GunProcessQueue.prototype.process = function () {
        return __awaiter(this, void 0, void 0, function () {
            var e_1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (this.isProcessing)
                            return [2 /*return*/];
                        this.isProcessing = true;
                        _a.label = 1;
                    case 1:
                        if (!this.count()) return [3 /*break*/, 6];
                        _a.label = 2;
                    case 2:
                        _a.trys.push([2, 4, , 5]);
                        return [4 /*yield*/, this.processNext()];
                    case 3:
                        _a.sent();
                        return [3 /*break*/, 5];
                    case 4:
                        e_1 = _a.sent();
                        console.error("Process Queue error", e_1.stack);
                        return [3 /*break*/, 5];
                    case 5: return [3 /*break*/, 1];
                    case 6:
                        this.isProcessing = false;
                        return [2 /*return*/];
                }
            });
        });
    };
    return GunProcessQueue;
}(GunQueue));

var GunGraphConnector = /** @class */ (function () {
    function GunGraphConnector(name) {
        if (name === void 0) { name = 'GunGraphConnector'; }
        this.isConnected = false;
        this.name = name;
        this.inputQueue = new GunProcessQueue(name + ".inputQueue");
        this.outputQueue = new GunProcessQueue(name + ".outputQueue");
        this.events = {
            graphData: new GunEvent(name + ".events.graphData"),
            receiveMessage: new GunEvent(name + ".events.receiveMessage"),
            connection: new GunEvent(name + ".events.connection")
        };
        this.__onConnectedChange = this.__onConnectedChange.bind(this);
        this.events.connection.on(this.__onConnectedChange);
    }
    GunGraphConnector.prototype.waitForConnection = function () {
        var _this = this;
        if (this.isConnected)
            return Promise.resolve();
        return new Promise(function (ok) {
            var onConnected = function (connected) {
                if (!connected)
                    return;
                ok();
                _this.events.connection.on(onConnected);
            };
            _this.events.connection.on(onConnected);
        });
    };
    /**
     * Send graph data for one or more nodes
     *
     * @returns A function to be called to clean up callback listeners
     */
    GunGraphConnector.prototype.put = function (_a) {
        var graph = _a.graph, _b = _a.msgId, _c = _a.replyTo, cb = _a.cb;
        return function () { };
    };
    /**
     * Request data for a given soul
     *
     * @returns A function to be called to clean up callback listeners
     */
    GunGraphConnector.prototype.get = function (_a) {
        var soul = _a.soul, cb = _a.cb, _b = _a.msgId, _c = _a.key // TODO
        ;
        return function () { };
    };
    /**
     * Queues outgoing messages for sending
     *
     * @param msgs The Gun wire protocol messages to enqueue
     */
    GunGraphConnector.prototype.send = function (msgs) {
        this.outputQueue.enqueueMany(msgs);
        if (this.isConnected)
            this.outputQueue.process();
    };
    /**
     * Queue incoming messages for processing
     *
     * @param msgs
     */
    GunGraphConnector.prototype.ingest = function (msgs) {
        this.inputQueue.enqueueMany(msgs).process();
    };
    GunGraphConnector.prototype.__onConnectedChange = function (connected) {
        if (connected) {
            this.isConnected = true;
            this.outputQueue.process();
        }
        else {
            this.isConnected = false;
        }
    };
    return GunGraphConnector;
}());

var GunGraphWireConnector = /** @class */ (function (_super) {
    __extends(GunGraphWireConnector, _super);
    function GunGraphWireConnector(name) {
        if (name === void 0) { name = 'GunWireProtocol'; }
        var _this = _super.call(this, name) || this;
        _this._callbacks = {};
        _this._onProcessedInput = _this._onProcessedInput.bind(_this);
        _this.inputQueue.completed.on(_this._onProcessedInput);
        return _this;
    }
    /**
     * Send graph data for one or more nodes
     *
     * @returns A function to be called to clean up callback listeners
     */
    GunGraphWireConnector.prototype.put = function (_a) {
        var graph = _a.graph, _b = _a.msgId, msgId = _b === void 0 ? '' : _b, _c = _a.replyTo, replyTo = _c === void 0 ? '' : _c, cb = _a.cb;
        if (!graph)
            return function () { };
        var msg = {
            put: graph
        };
        if (msgId)
            msg['#'] = msgId;
        if (replyTo)
            msg['@'] = replyTo;
        return this.req(msg, cb);
    };
    /**
     * Request data for a given soul
     *
     * @returns A function to be called to clean up callback listeners
     */
    GunGraphWireConnector.prototype.get = function (_a) {
        var soul = _a.soul, cb = _a.cb, _b = _a.msgId, msgId = _b === void 0 ? '' : _b, _c = _a.key // TODO
        ;
        var get = { '#': soul };
        // if (key) get["."] = key
        var msg = { get: get };
        if (msgId)
            msg['#'] = msgId;
        return this.req(msg, cb);
    };
    /**
     * Send a message that expects responses via @
     *
     * @param msg
     * @param cb
     */
    GunGraphWireConnector.prototype.req = function (msg, cb) {
        var _this = this;
        var now = new Date().getTime();
        var done;
        var reqId = (msg['#'] = msg['#'] || generateMessageId());
        var cbWrap = function (resp) {
            if (!done) {
                done = new Date().getTime();
                var duration = done - now;
                if (duration > 500) {
                    console.log('slow req', duration, msg.put ? Object.keys(msg.put) : msg);
                }
            }
            if (cb)
                return cb(resp);
        };
        if (cb)
            this._callbacks[reqId] = cbWrap;
        this.send([msg]);
        return function () {
            delete _this._callbacks[reqId];
        };
    };
    GunGraphWireConnector.prototype._onProcessedInput = function (msg) {
        if (!msg)
            return;
        var id = msg['#'];
        var replyTo = msg['@'];
        if ('put' in msg) {
            if (msg.put)
                this.events.graphData.trigger(msg.put, id, replyTo);
        }
        if (replyTo) {
            var cb = this._callbacks[replyTo];
            if (cb)
                cb(msg);
        }
        this.events.receiveMessage.trigger(msg);
    };
    return GunGraphWireConnector;
}(GunGraphConnector));

/*! *****************************************************************************
Copyright (c) Microsoft Corporation. All rights reserved.
Licensed under the Apache License, Version 2.0 (the "License"); you may not use
this file except in compliance with the License. You may obtain a copy of the
License at http://www.apache.org/licenses/LICENSE-2.0

THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
MERCHANTABLITY OR NON-INFRINGEMENT.

See the Apache Version 2.0 License for specific language governing permissions
and limitations under the License.
***************************************************************************** */
/* global Reflect, Promise */

var extendStatics$1 = function(d, b) {
    extendStatics$1 = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return extendStatics$1(d, b);
};

function __extends$1(d, b) {
    extendStatics$1(d, b);
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
}

function __read(o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
}

function __spread() {
    for (var ar = [], i = 0; i < arguments.length; i++)
        ar = ar.concat(__read(arguments[i]));
    return ar;
}

var Event = /** @class */ (function () {
    function Event(type, target) {
        this.target = target;
        this.type = type;
    }
    return Event;
}());
var ErrorEvent = /** @class */ (function (_super) {
    __extends$1(ErrorEvent, _super);
    function ErrorEvent(error, target) {
        var _this = _super.call(this, 'error', target) || this;
        _this.message = error.message;
        _this.error = error;
        return _this;
    }
    return ErrorEvent;
}(Event));
var CloseEvent = /** @class */ (function (_super) {
    __extends$1(CloseEvent, _super);
    function CloseEvent(code, reason, target) {
        if (code === void 0) { code = 1000; }
        if (reason === void 0) { reason = ''; }
        var _this = _super.call(this, 'close', target) || this;
        _this.wasClean = true;
        _this.code = code;
        _this.reason = reason;
        return _this;
    }
    return CloseEvent;
}(Event));

var getGlobalWebSocket = function () {
    if (typeof WebSocket !== 'undefined') {
        // @ts-ignore
        return WebSocket;
    }
};
/**
 * Returns true if given argument looks like a WebSocket class
 */
var isWebSocket = function (w) { return typeof w !== 'undefined' && !!w && w.CLOSING === 2; };
var DEFAULT = {
    maxReconnectionDelay: 10000,
    minReconnectionDelay: 1000 + Math.random() * 4000,
    minUptime: 5000,
    reconnectionDelayGrowFactor: 1.3,
    connectionTimeout: 4000,
    maxRetries: Infinity,
    maxEnqueuedMessages: Infinity,
    startClosed: false,
    debug: false,
};
var ReconnectingWebSocket = /** @class */ (function () {
    function ReconnectingWebSocket(url, protocols, options) {
        var _this = this;
        if (options === void 0) { options = {}; }
        this._listeners = {
            error: [],
            message: [],
            open: [],
            close: [],
        };
        this._retryCount = -1;
        this._shouldReconnect = true;
        this._connectLock = false;
        this._binaryType = 'blob';
        this._closeCalled = false;
        this._messageQueue = [];
        /**
         * An event listener to be called when the WebSocket connection's readyState changes to CLOSED
         */
        this.onclose = undefined;
        /**
         * An event listener to be called when an error occurs
         */
        this.onerror = undefined;
        /**
         * An event listener to be called when a message is received from the server
         */
        this.onmessage = undefined;
        /**
         * An event listener to be called when the WebSocket connection's readyState changes to OPEN;
         * this indicates that the connection is ready to send and receive data
         */
        this.onopen = undefined;
        this._handleOpen = function (event) {
            _this._debug('open event');
            var _a = _this._options.minUptime, minUptime = _a === void 0 ? DEFAULT.minUptime : _a;
            clearTimeout(_this._connectTimeout);
            _this._uptimeTimeout = setTimeout(function () { return _this._acceptOpen(); }, minUptime);
            // @ts-ignore
            _this._ws.binaryType = _this._binaryType;
            // send enqueued messages (messages sent before websocket open event)
            _this._messageQueue.forEach(function (message) { return _this._ws.send(message); });
            _this._messageQueue = [];
            if (_this.onopen) {
                _this.onopen(event);
            }
            _this._listeners.open.forEach(function (listener) { return _this._callEventListener(event, listener); });
        };
        this._handleMessage = function (event) {
            _this._debug('message event');
            if (_this.onmessage) {
                _this.onmessage(event);
            }
            _this._listeners.message.forEach(function (listener) { return _this._callEventListener(event, listener); });
        };
        this._handleError = function (event) {
            _this._debug('error event', event.message);
            _this._disconnect(undefined, event.message === 'TIMEOUT' ? 'timeout' : undefined);
            if (_this.onerror) {
                _this.onerror(event);
            }
            _this._debug('exec error listeners');
            _this._listeners.error.forEach(function (listener) { return _this._callEventListener(event, listener); });
            _this._connect();
        };
        this._handleClose = function (event) {
            _this._debug('close event');
            _this._clearTimeouts();
            if (_this._shouldReconnect) {
                _this._connect();
            }
            if (_this.onclose) {
                _this.onclose(event);
            }
            _this._listeners.close.forEach(function (listener) { return _this._callEventListener(event, listener); });
        };
        this._url = url;
        this._protocols = protocols;
        this._options = options;
        if (this._options.startClosed) {
            this._shouldReconnect = false;
        }
        this._connect();
    }
    Object.defineProperty(ReconnectingWebSocket, "CONNECTING", {
        get: function () {
            return 0;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ReconnectingWebSocket, "OPEN", {
        get: function () {
            return 1;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ReconnectingWebSocket, "CLOSING", {
        get: function () {
            return 2;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ReconnectingWebSocket, "CLOSED", {
        get: function () {
            return 3;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ReconnectingWebSocket.prototype, "CONNECTING", {
        get: function () {
            return ReconnectingWebSocket.CONNECTING;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ReconnectingWebSocket.prototype, "OPEN", {
        get: function () {
            return ReconnectingWebSocket.OPEN;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ReconnectingWebSocket.prototype, "CLOSING", {
        get: function () {
            return ReconnectingWebSocket.CLOSING;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ReconnectingWebSocket.prototype, "CLOSED", {
        get: function () {
            return ReconnectingWebSocket.CLOSED;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ReconnectingWebSocket.prototype, "binaryType", {
        get: function () {
            return this._ws ? this._ws.binaryType : this._binaryType;
        },
        set: function (value) {
            this._binaryType = value;
            if (this._ws) {
                // @ts-ignore
                this._ws.binaryType = value;
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ReconnectingWebSocket.prototype, "retryCount", {
        /**
         * Returns the number or connection retries
         */
        get: function () {
            return Math.max(this._retryCount, 0);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ReconnectingWebSocket.prototype, "bufferedAmount", {
        /**
         * The number of bytes of data that have been queued using calls to send() but not yet
         * transmitted to the network. This value resets to zero once all queued data has been sent.
         * This value does not reset to zero when the connection is closed; if you keep calling send(),
         * this will continue to climb. Read only
         */
        get: function () {
            var bytes = this._messageQueue.reduce(function (acc, message) {
                if (typeof message === 'string') {
                    acc += message.length; // not byte size
                }
                else if (message instanceof Blob) {
                    acc += message.size;
                }
                else {
                    acc += message.byteLength;
                }
                return acc;
            }, 0);
            return bytes + (this._ws ? this._ws.bufferedAmount : 0);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ReconnectingWebSocket.prototype, "extensions", {
        /**
         * The extensions selected by the server. This is currently only the empty string or a list of
         * extensions as negotiated by the connection
         */
        get: function () {
            return this._ws ? this._ws.extensions : '';
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ReconnectingWebSocket.prototype, "protocol", {
        /**
         * A string indicating the name of the sub-protocol the server selected;
         * this will be one of the strings specified in the protocols parameter when creating the
         * WebSocket object
         */
        get: function () {
            return this._ws ? this._ws.protocol : '';
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ReconnectingWebSocket.prototype, "readyState", {
        /**
         * The current state of the connection; this is one of the Ready state constants
         */
        get: function () {
            if (this._ws) {
                return this._ws.readyState;
            }
            return this._options.startClosed
                ? ReconnectingWebSocket.CLOSED
                : ReconnectingWebSocket.CONNECTING;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ReconnectingWebSocket.prototype, "url", {
        /**
         * The URL as resolved by the constructor
         */
        get: function () {
            return this._ws ? this._ws.url : '';
        },
        enumerable: true,
        configurable: true
    });
    /**
     * Closes the WebSocket connection or connection attempt, if any. If the connection is already
     * CLOSED, this method does nothing
     */
    ReconnectingWebSocket.prototype.close = function (code, reason) {
        if (code === void 0) { code = 1000; }
        this._closeCalled = true;
        this._shouldReconnect = false;
        this._clearTimeouts();
        if (!this._ws) {
            this._debug('close enqueued: no ws instance');
            return;
        }
        if (this._ws.readyState === this.CLOSED) {
            this._debug('close: already closed');
            return;
        }
        this._ws.close(code, reason);
    };
    /**
     * Closes the WebSocket connection or connection attempt and connects again.
     * Resets retry counter;
     */
    ReconnectingWebSocket.prototype.reconnect = function (code, reason) {
        this._shouldReconnect = true;
        this._closeCalled = false;
        this._retryCount = -1;
        if (!this._ws || this._ws.readyState === this.CLOSED) {
            this._connect();
        }
        else {
            this._disconnect(code, reason);
            this._connect();
        }
    };
    /**
     * Enqueue specified data to be transmitted to the server over the WebSocket connection
     */
    ReconnectingWebSocket.prototype.send = function (data) {
        if (this._ws && this._ws.readyState === this.OPEN) {
            this._debug('send', data);
            this._ws.send(data);
        }
        else {
            var _a = this._options.maxEnqueuedMessages, maxEnqueuedMessages = _a === void 0 ? DEFAULT.maxEnqueuedMessages : _a;
            if (this._messageQueue.length < maxEnqueuedMessages) {
                this._debug('enqueue', data);
                this._messageQueue.push(data);
            }
        }
    };
    /**
     * Register an event handler of a specific event type
     */
    ReconnectingWebSocket.prototype.addEventListener = function (type, listener) {
        if (this._listeners[type]) {
            // @ts-ignore
            this._listeners[type].push(listener);
        }
    };
    /**
     * Removes an event listener
     */
    ReconnectingWebSocket.prototype.removeEventListener = function (type, listener) {
        if (this._listeners[type]) {
            // @ts-ignore
            this._listeners[type] = this._listeners[type].filter(function (l) { return l !== listener; });
        }
    };
    ReconnectingWebSocket.prototype._debug = function () {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        if (this._options.debug) {
            // not using spread because compiled version uses Symbols
            // tslint:disable-next-line
            console.log.apply(console, __spread(['RWS>'], args));
        }
    };
    ReconnectingWebSocket.prototype._getNextDelay = function () {
        var _a = this._options, _b = _a.reconnectionDelayGrowFactor, reconnectionDelayGrowFactor = _b === void 0 ? DEFAULT.reconnectionDelayGrowFactor : _b, _c = _a.minReconnectionDelay, minReconnectionDelay = _c === void 0 ? DEFAULT.minReconnectionDelay : _c, _d = _a.maxReconnectionDelay, maxReconnectionDelay = _d === void 0 ? DEFAULT.maxReconnectionDelay : _d;
        var delay = 0;
        if (this._retryCount > 0) {
            delay =
                minReconnectionDelay * Math.pow(reconnectionDelayGrowFactor, this._retryCount - 1);
            if (delay > maxReconnectionDelay) {
                delay = maxReconnectionDelay;
            }
        }
        this._debug('next delay', delay);
        return delay;
    };
    ReconnectingWebSocket.prototype._wait = function () {
        var _this = this;
        return new Promise(function (resolve) {
            setTimeout(resolve, _this._getNextDelay());
        });
    };
    ReconnectingWebSocket.prototype._getNextUrl = function (urlProvider) {
        if (typeof urlProvider === 'string') {
            return Promise.resolve(urlProvider);
        }
        if (typeof urlProvider === 'function') {
            var url = urlProvider();
            if (typeof url === 'string') {
                return Promise.resolve(url);
            }
            if (url.then) {
                return url;
            }
        }
        throw Error('Invalid URL');
    };
    ReconnectingWebSocket.prototype._connect = function () {
        var _this = this;
        if (this._connectLock || !this._shouldReconnect) {
            return;
        }
        this._connectLock = true;
        var _a = this._options, _b = _a.maxRetries, maxRetries = _b === void 0 ? DEFAULT.maxRetries : _b, _c = _a.connectionTimeout, connectionTimeout = _c === void 0 ? DEFAULT.connectionTimeout : _c, _d = _a.WebSocket, WebSocket = _d === void 0 ? getGlobalWebSocket() : _d;
        if (this._retryCount >= maxRetries) {
            this._debug('max retries reached', this._retryCount, '>=', maxRetries);
            return;
        }
        this._retryCount++;
        this._debug('connect', this._retryCount);
        this._removeListeners();
        if (!isWebSocket(WebSocket)) {
            throw Error('No valid WebSocket class provided');
        }
        this._wait()
            .then(function () { return _this._getNextUrl(_this._url); })
            .then(function (url) {
            // close could be called before creating the ws
            if (_this._closeCalled) {
                return;
            }
            _this._debug('connect', { url: url, protocols: _this._protocols });
            _this._ws = _this._protocols
                ? new WebSocket(url, _this._protocols)
                : new WebSocket(url);
            // @ts-ignore
            _this._ws.binaryType = _this._binaryType;
            _this._connectLock = false;
            _this._addListeners();
            _this._connectTimeout = setTimeout(function () { return _this._handleTimeout(); }, connectionTimeout);
        });
    };
    ReconnectingWebSocket.prototype._handleTimeout = function () {
        this._debug('timeout event');
        this._handleError(new ErrorEvent(Error('TIMEOUT'), this));
    };
    ReconnectingWebSocket.prototype._disconnect = function (code, reason) {
        if (code === void 0) { code = 1000; }
        this._clearTimeouts();
        if (!this._ws) {
            return;
        }
        this._removeListeners();
        try {
            this._ws.close(code, reason);
            this._handleClose(new CloseEvent(code, reason, this));
        }
        catch (error) {
            // ignore
        }
    };
    ReconnectingWebSocket.prototype._acceptOpen = function () {
        this._debug('accept open');
        this._retryCount = 0;
    };
    ReconnectingWebSocket.prototype._callEventListener = function (event, listener) {
        if ('handleEvent' in listener) {
            // @ts-ignore
            listener.handleEvent(event);
        }
        else {
            // @ts-ignore
            listener(event);
        }
    };
    ReconnectingWebSocket.prototype._removeListeners = function () {
        if (!this._ws) {
            return;
        }
        this._debug('removeListeners');
        this._ws.removeEventListener('open', this._handleOpen);
        this._ws.removeEventListener('close', this._handleClose);
        this._ws.removeEventListener('message', this._handleMessage);
        // @ts-ignore
        this._ws.removeEventListener('error', this._handleError);
    };
    ReconnectingWebSocket.prototype._addListeners = function () {
        if (!this._ws) {
            return;
        }
        this._debug('addListeners');
        this._ws.addEventListener('open', this._handleOpen);
        this._ws.addEventListener('close', this._handleClose);
        this._ws.addEventListener('message', this._handleMessage);
        // @ts-ignore
        this._ws.addEventListener('error', this._handleError);
    };
    ReconnectingWebSocket.prototype._clearTimeouts = function () {
        clearTimeout(this._connectTimeout);
        clearTimeout(this._uptimeTimeout);
    };
    return ReconnectingWebSocket;
}());

var WebSocketGraphConnector = /** @class */ (function (_super) {
    __extends(WebSocketGraphConnector, _super);
    function WebSocketGraphConnector(url, WS) {
        if (WS === void 0) { WS = WebSocket; }
        var _this = _super.call(this, "<WebSocketGraphConnector " + url + ">") || this;
        _this.url = url;
        _this.outputQueue.completed.on(_this._onOutputProcessed.bind(_this));
        _this._ws = _this._connectWebSocket(WS);
        return _this;
    }
    WebSocketGraphConnector.prototype._connectWebSocket = function (WS) {
        var _this = this;
        if (WS === void 0) { WS = WebSocket; }
        var ws = new ReconnectingWebSocket(this.url.replace(/^http/, 'ws'), [], {
            WebSocket: WS
        });
        ws.addEventListener('message', this._onReceiveSocketData.bind(this));
        ws.addEventListener('open', function () { return _this.events.connection.trigger(true); });
        ws.addEventListener('close', function () { return _this.events.connection.trigger(false); });
        return ws;
    };
    WebSocketGraphConnector.prototype._sendToWebsocket = function (msgs) {
        if (!msgs.length)
            return msgs;
        if (msgs.length === 1) {
            this._ws.send(JSON.stringify(msgs[0]));
        }
        else if (msgs.length > 0) {
            this._ws.send(JSON.stringify(msgs));
        }
        return msgs;
    };
    WebSocketGraphConnector.prototype._onOutputProcessed = function (msg) {
        if (msg)
            this._sendToWebsocket([msg]);
    };
    WebSocketGraphConnector.prototype._onReceiveSocketData = function (msg) {
        var raw = msg.data;
        var json = JSON.parse(raw);
        if (Array.isArray(json)) {
            this.ingest(json);
        }
        else {
            this.ingest([json]);
        }
    };
    return WebSocketGraphConnector;
}(GunGraphWireConnector));

/**
 * Main entry point for ChainGun
 *
 * Usage:
 *
 *   const gun = new ChainGun({ peers: ["https://notabug.io/gun"]})
 *   gun.get("nab/things/59382d2a08b7d7073415b5b6ae29dfe617690d74").on(thing => console.log(this))
 */
var ChainGun = /** @class */ (function () {
    function ChainGun(opt, LinkClass) {
        if (LinkClass === void 0) { LinkClass = ChainGunLink; }
        if (opt && opt.graph) {
            this.graph = opt.graph;
        }
        else {
            this.graph = new GunGraph();
            this.graph.use(diffGunCRDT);
            this.graph.use(diffGunCRDT, 'write');
        }
        this._opt = {};
        if (opt)
            this.opt(opt);
        this.LinkClass = LinkClass;
    }
    /**
     * Set ChainGun configuration options
     *
     * @param options
     */
    ChainGun.prototype.opt = function (options) {
        var _this = this;
        this._opt = __assign(__assign({}, this._opt), options);
        if (options.peers) {
            options.peers.forEach(function (peer) {
                return _this.graph.connect(new WebSocketGraphConnector(peer, _this._opt.WS));
            });
        }
        return this;
    };
    /**
     * Traverse a location in the graph
     *
     * @param key Key to read data from
     * @param cb
     * @returns New chain context corresponding to given key
     */
    ChainGun.prototype.get = function (soul, cb) {
        return new this.LinkClass(this, soul);
    };
    return ChainGun;
}());

export { ChainGun, ChainGunLink, GunEvent, GunGraph, GunGraphConnector, GunGraphWireConnector, GunProcessQueue, GunQueue, WebSocketGraphConnector, addMissingState, diffGunCRDT, diffSets, flattenGraphData, generateMessageId, getPathData, mergeGraph, mergeGunNodes, nodeToGraph };
//# sourceMappingURL=chaingun.es5.js.map
