"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var GunGraphWireConnector_1 = require("./GunGraphWireConnector");
var reconnecting_websocket_1 = require("reconnecting-websocket");
var WebSocketGraphConnector = /** @class */ (function (_super) {
    __extends(WebSocketGraphConnector, _super);
    function WebSocketGraphConnector(url, WS) {
        if (WS === void 0) { WS = WebSocket; }
        var _this = _super.call(this, "<WebSocketGraphConnector " + url + ">") || this;
        _this.url = url;
        _this.outputQueue.completed.on(_this._onOutputProcessed.bind(_this));
        _this._ws = _this._connectWebSocket(WS);
        return _this;
    }
    WebSocketGraphConnector.prototype._connectWebSocket = function (WS) {
        var _this = this;
        if (WS === void 0) { WS = WebSocket; }
        var ws = new reconnecting_websocket_1.default(this.url.replace(/^http/, 'ws'), [], {
            WebSocket: WS
        });
        ws.addEventListener('message', this._onReceiveSocketData.bind(this));
        ws.addEventListener('open', function () { return _this.events.connection.trigger(true); });
        ws.addEventListener('close', function () { return _this.events.connection.trigger(false); });
        return ws;
    };
    WebSocketGraphConnector.prototype._sendToWebsocket = function (msgs) {
        if (!msgs.length)
            return msgs;
        if (msgs.length === 1) {
            this._ws.send(JSON.stringify(msgs[0]));
        }
        else if (msgs.length > 0) {
            this._ws.send(JSON.stringify(msgs));
        }
        return msgs;
    };
    WebSocketGraphConnector.prototype._onOutputProcessed = function (msg) {
        if (msg)
            this._sendToWebsocket([msg]);
    };
    WebSocketGraphConnector.prototype._onReceiveSocketData = function (msg) {
        var raw = msg.data;
        var json = JSON.parse(raw);
        if (Array.isArray(json)) {
            this.ingest(json);
        }
        else {
            this.ingest([json]);
        }
    };
    return WebSocketGraphConnector;
}(GunGraphWireConnector_1.GunGraphWireConnector));
exports.WebSocketGraphConnector = WebSocketGraphConnector;
//# sourceMappingURL=WebSocketGraphConnector.js.map