declare type EventCb<T = any, U = any, V = any> = (a?: T, b?: U, c?: V) => void;
/**
 * Generic event/listener system
 */
export declare class GunEvent<T = any, U = any, V = any> {
    name: string;
    private _listeners;
    constructor(name?: string);
    /**
     * @returns number of currently subscribed listeners
     */
    listenerCount(): number;
    /**
     * Register a listener on this event
     *
     * @param cb the callback to subscribe
     */
    on(cb: EventCb<T, U, V>): this | undefined;
    /**
     * Unregister a listener on this event
     * @param cb the callback to unsubscribe
     */
    off(cb: EventCb<T, U, V>): this;
    /**
     * Unregister all listeners on this event
     */
    reset(): this;
    /**
     * Trigger this event
     */
    trigger(a?: T, b?: U, c?: V): this;
}
export {};
