import { GunGraphConnector } from './GunGraphConnector';
export declare abstract class GunGraphWireConnector extends GunGraphConnector {
    private _callbacks;
    constructor(name?: string);
    /**
     * Send graph data for one or more nodes
     *
     * @returns A function to be called to clean up callback listeners
     */
    put({ graph, msgId, replyTo, cb }: {
        graph: GunGraphData;
        msgId?: string;
        replyTo?: string;
        cb?: GunMsgCb;
    }): () => void;
    /**
     * Request data for a given soul
     *
     * @returns A function to be called to clean up callback listeners
     */
    get({ soul, cb, msgId, key }: {
        soul: string;
        msgId?: string;
        key?: string;
        cb?: GunMsgCb;
    }): () => void;
    /**
     * Send a message that expects responses via @
     *
     * @param msg
     * @param cb
     */
    req(msg: GunMsg, cb?: GunMsgCb): () => void;
    private _onProcessedInput;
}
